#include <allegro.h>
#include "Global.h"
#include "Menus.h"
#include "Player.h"
#include <tdgui.h>
#include <linklist.h>
#include <stdio.h>
#include "Sounds.h"

void PrepareScreen();
void StartUpMainMenu(LinkList<Player>& players);
void ShutDownMainMenu();
bool DoPlayerMenu(Player& data);
//Modifies data only if data is OK'd
//Returns true if OK'd else false

LinkList<Player>* gui_players = NULL;
char scrx_buf[5];
char scry_buf[5];

//MainMenu returns true if the game should proceed else false
bool MainMenu(LinkList<Player>& players) {
  PrepareScreen();
  centre_dialog(mainmenu);
  while (gui_ret != 0) {
    StartUpMainMenu(players);
    moveable_do_dialog(mainmenu, 4);
    switch (gui_ret) {
    case 1:
      //Play the game
      ShutDownMainMenu();
      return true;
      break;
    case 2: {
      //Add a player
      Player* newPlayer = new Player();
      if (DoPlayerMenu(*newPlayer))
        //Menu was OK'd
        players._MoveData(newPlayer);
      else
        //Menu was canceled
        delete newPlayer;
      break;}
    case 3:
      //Edit a player
      if (players.Length())
        DoPlayerMenu(players[gui_player_selected]);
      break;
    case 4:
      //Delete a player
      if (players.Length()) {
        PlaySound(warning);
        Player* temp = players.GetItem(gui_player_selected);
          if (billalert("Delete Player", "Are you sure you delete the player", 
                        temp->GetName(), "&OK", "Cancel", 'o', 27) == 1)
            players.DeleteItem(gui_player_selected);
      }
      break;
    case 5:
      PlaySound(warning);
      if (billalert("Quit DeathWorms", "Are you sure you", "want to quit DeathWorms?", "&OK", "Cancel", 'o', 27) == 2)
        gui_ret = -1;
      else
        gui_ret = 0;
      break;
    case 6:
      //Toggle a player on/off
      players.GetItem(gui_player_selected)->ToggleActive();
      break;
    }
  ShutDownMainMenu();
  }
  ShutDownMainMenu();
  return false;
}

//Creates GUI background
void PrepareScreen() {
  clear_to_color(screen, makecol(48, 48, 48));
  text_mode(-1);
  textout_centre(screen, font, "DeathWorms V1.0 (c) 2000", GUI_X/2, 0, makecol(255, 255, 255));
  textout_centre(screen, font, "by:", GUI_X/2, 12, makecol(255, 255, 255));
  textout_centre(screen, font, "Jason Winnebeck (Programming, Design, Concept)", GUI_X/2, 24, makecol(255, 255, 255));
  textout_centre(screen, font, "Jon Hilliker (Sounds, Concept)", GUI_X/2, 36, makecol(255, 255, 255));
  textout_centre(screen, font, "Justin Jackson (Concept)", GUI_X/2, 48, makecol(255, 255, 255));
  textout_centre(screen, font, "Offical website: http://www.rit.edu/~jpw9607/", GUI_X/2, GUI_Y-text_height(font), makecol(192, 192, 192));
}

//Functions for the main menu
//Inits vars in dialog
void StartUpMainMenu(LinkList<Player>& players) {
  gui_ret = -1;
  gui_players = &players;
  text_mode(0); //Go to background drawing
  itoa(scrx, scrx_buf, 10);
  itoa(scry, scry_buf, 10);
  if (craters)
    gui_crater_checkbox = D_SELECTED;
  else
    gui_crater_checkbox = 0;

  gui_gamespeed = MAX_SPEED - game_speed + 1;
  gui_mortarrate = (crater_rate * game_speed) - MIN_CRATER_RATE;
  //Because of integer precision it might fall below 0
  if (gui_mortarrate < 0)
    gui_mortarrate = 0;

  clear_keybuf();
}

//Updates game variables from dialog
void ShutDownMainMenu() {
  scrx = atoi(scrx_buf);
  scry = atoi(scry_buf);

  if (gui_crater_checkbox & D_SELECTED)
    craters = 1;
  else
    craters = 0;

  game_speed = MAX_SPEED - gui_gamespeed + 1;
  //Gets value in ms, converts to frames
  crater_rate = (gui_mortarrate + MIN_CRATER_RATE) / game_speed;

  text_mode(-1); //Return to transparent drawing
}

//GUI functions for the main menu
char* PlayerListGetter(int index, int* list_size) {
  static char list_buf[64] = "\0";
  if (index < 0) {
    *list_size = gui_players->Length();
    return NULL;
  } else {
    Player* temp = gui_players->GetItem(index);
    if (temp->IsActive())
      sprintf(list_buf, "*%s -- Wins: %i Losses: %i", temp->GetName(), temp->GetWins(), temp->GetLosses());
    else
      sprintf(list_buf, " %s -- Wins: %i Losses: %i", temp->GetName(), temp->GetWins(), temp->GetLosses());
    return list_buf;
  }
}

//Global GUI Helper functions
int gui_ret = -1;

int SetRet(void *dp3, int d2) {
  PlaySound(click);
  gui_ret = d2;
  return D_O_K;
}

int d_check_exit(int msg, DIALOG *d, int c) {
  if (msg == MSG_IDLE)
    if (gui_ret != -1)
      return D_CLOSE;
    else
      return D_O_K;

  return D_O_K;
}