#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <fstream.h>
#include <allegro.h>

const int KEYBOARD = 0;
const int JOYSTICK = 1;

const int LEFT = 0;
const int UP = 1;
const int RIGHT = 2;
const int DOWN = 3;

class Player {
public:
  Player();
  Player(Player& rhs);
  Player(char* name2, int col2, int sound2, int control, int up, int left, int right, int down);
  ~Player();
  void Serialize(ofstream& file);
  bool Load(ifstream& file);//true on error
  
  void SetPos(int x2, int y2, int dir2);
  void Reset();   //Player isn't dead anymore
  bool IsDead();
  char* GetName();//returns name
  void SetName(char* name2);
  void GetColors(int& red, int& green, int& blue);
  void SetColor(int col2);
  int  GetSound();
  void SetSound(int sound2);
  int  GetInput();
  void SetInput(int input2);
  void GetControls(int& up, int& left, int& right, int& down);
  void SetControls(int up, int left, int right, int down);
  bool IsActive();
  void ToggleActive();

  void Draw();   //Plots the pixel
  void Update(); //Gets controls
  bool Calc();   //Moves, does detection

  void Win();    //Tell the player he has won!
                 //Losses are handled thru calc when dead
  int  GetWins();//Return wins
  int  GetLosses();//Return losses
  void ResetScores();//wins = losses = 0

  Player& operator = (Player& rhs);

private:
  int x, y;
  int dir;
  int col;
  int c_up, c_left, c_right, c_down;
  int input;     //Method of input
  bool dead;     //if this player is dead
  bool active;   //true if this player will be playing
  int sound;
  int wins, losses; //record

  char* name;    //Players name
};

#endif