#include "PlayerMenu.h"
#include <string.h>
#include "Sounds.h"
#include "Player.h"

int c_left, c_up, c_down, c_right;

bool DoPlayerMenu(Player& data) {
  //Startup code
  gui_ret = -1;
  data.GetColors(gui_colorbox_r, gui_colorbox_g, gui_colorbox_b);
  data.GetControls(c_up, c_left, c_right, c_down);
  strcpy(gui_name_buf, data.GetName());
  gui_sound_choice = data.GetSound() - FIRSTSOUND;
  gui_control_choice = data.GetInput();

  clear_keybuf();

  //Do dialog
  centre_dialog(playermenu);
  while (gui_ret == -1) {
    moveable_do_dialog(playermenu, 1);
    switch (gui_ret) {
    case 1:
      //OK'd, copy data over
      data.SetColor(makecol(gui_colorbox_r, gui_colorbox_g, gui_colorbox_b));
      data.SetName(gui_name_buf);
      data.SetSound(gui_sound_choice + FIRSTSOUND);
      data.SetInput(gui_control_choice);
      data.SetControls(c_up, c_left, c_right, c_down);
      gui_ret = -1;
      return true;
      break;
    case 2:
      gui_cdialog_reset = 0;
      centre_dialog(cdialog);
      clear_keybuf();
      moveable_do_dialog(cdialog, 1);
      gui_ret = -1;
      break;
    }
  }

  //Shutdown code
  gui_ret = -1; //This is so the calling GUI doesn't quit!

  return false;
}

char* SoundListGetter(int index, int* list_size) {
  static char* strings[] = {
    "beep", "bip", "boop", "die", "doh", "wee", "zoop"
  };

  if (index < 0) {
    *list_size = TURNSOUNDS;
    return NULL;
  } else {
    return strings[index];
  }
}

char* ControlListGetter(int index, int* list_size) {
  static char* strings[] = {
    "Keyboard", "Joystick 1", "Joystick 2", "Joystick 3", "Joystick 4",
    "Joystick 5", "Joystick 6", "Joystick 7", "Joystick 8"
  };

  if (index < 0) {
    *list_size = 1 + num_joysticks;
    return NULL;
  } else {
    return strings[index];
  }
}

int d_colorbox_proc(int msg, DIALOG* d, int c) {
  //These are to detect changes, so we can optimize updating
  static int r, g, b;
  switch (msg) {
  case MSG_START:
    r = g = b = 0;
    break;
  case MSG_IDLE:
    if ((r != gui_colorbox_r) || (g != gui_colorbox_g) || (b != gui_colorbox_b)) {
      r = gui_colorbox_r;
      g = gui_colorbox_g;
      b = gui_colorbox_b;
      scare_mouse();
      acquire_screen();
      rectfill(screen, d->x, d->y, d->x + d->w, d->y + d->h, makecol(r, g, b));
      release_screen();
      unscare_mouse();
    }
    break;
  }
  return D_O_K;
}

int d_get_ctrls(int msg, DIALOG *d, int c) {
  switch (msg) {
  case MSG_START:
    strcpy(currkey, "Turning up");
    break;
  case MSG_IDLE:
    switch (d->d1) {
    case 0:
      c_up = readkey() >> 8;
      strcpy(currkey, "Turning Down");
      d->d1++;
      return D_REDRAW;
    case 1:
      c_down = readkey() >> 8;
      strcpy(currkey, "Turning Left");
      d->d1++;
      return D_REDRAW;
    case 2:
      c_left = readkey() >> 8;
      strcpy(currkey, "Turning Right");
      d->d1++;
      return D_REDRAW;
    case 3:
      c_right = readkey() >> 8;
      d->d1++;
    default:
      return D_CLOSE;
    }
    break;
  }
  return D_O_K;
}