#include "sounds.h"
#include <allegro.h>
#include <jrnd.h>
#include <stdio.h>

SAMPLE* s_lose = NULL;
SAMPLE* s_tie = NULL;
SAMPLE* s_turn[TURNSOUNDS] = {NULL};
SAMPLE* s_click = NULL;
SAMPLE* s_warn = NULL;
SAMPLE* s_sucks = NULL;

const int TOTAL_EXP = 2;
SAMPLE* s_exp[TOTAL_EXP] = {NULL, NULL};

bool LoadSound(SAMPLE* &data, char* name);

void PlaySound(int event) {
  switch (event) {
  //Gui events
  case click:
    play_sample(s_click, 255, 128, 1000, 0);
    break;
  case warning:
    play_sample(s_warn, 255, 128, 1000, 0);
    break;
  case sucks:
    play_sample(s_sucks, 255, 128, 1000, 0);
    break;
  case lose:
    play_sample(s_lose, 255, 128, 1000, 0);
    break;
  case tie:
    play_sample(s_tie, 255, 128, 1000, 0);
    break;
  case explosion:
    play_sample(s_exp[getrnd(TOTAL_EXP)], 180, 128, 700 + getrnd(600), 0);
    break;
    //Game events
  default:
   play_sample(s_turn[event-FIRSTSOUND], 255, 128, 700 + getrnd(600), 0);
  }
}

bool LoadSounds() {
  if (LoadSound(s_lose, "lisa"))
    return true;
  if (LoadSound(s_click, "mouse"))
    return true;
  if (LoadSound(s_warn, "neenee"))
    return true;
  if (LoadSound(s_tie, "haha"))
    return true;
  if (LoadSound(s_turn[beep-FIRSTSOUND], "beep"))
    return true;
  if (LoadSound(s_turn[bip-FIRSTSOUND], "bip"))
    return true;
  if (LoadSound(s_turn[boop-FIRSTSOUND], "boop"))
    return true;
  if (LoadSound(s_turn[die-FIRSTSOUND], "die"))
    return true;
  if (LoadSound(s_turn[zoop-FIRSTSOUND], "zoop"))
    return true;
  if (LoadSound(s_turn[doh-FIRSTSOUND], "doh"))
    return true;
  if (LoadSound(s_turn[wee-FIRSTSOUND], "wee"))
    return true;
  if (LoadSound(s_sucks, "sucks"))
    return true;
  if (LoadSound(s_exp[0], "exp1"))
    return true;
  if (LoadSound(s_exp[1], "exp2"))
    return true;
  return false;
}

bool LoadSound(SAMPLE* &data, char* name) {
  char filename[256] = "\0";
  sprintf(filename, "sounds/%s.wav", name);
  if ((data = load_sample(filename)) == NULL) {
    set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
    allegro_message("Cannot load %s: %s", filename, allegro_error);
    return true;
  }
  return false;
}

void UnloadSounds() {
  for (int c=0; c<TURNSOUNDS; c++)
    destroy_sample(s_turn[c]);
  for (c=0; c<TOTAL_EXP; c++)
    destroy_sample(s_exp[c]);
  destroy_sample(s_lose);
  destroy_sample(s_sucks);
  destroy_sample(s_tie);
  destroy_sample(s_click);
  destroy_sample(s_warn);
}